RandomYield = {
  yield = math.random() * 1.2 + 0.3,
  fruitTypesYield = {}
}

function RandomYield:randomizeYields()
  for _, fruitType in ipairs(g_currentMission.fruitTypeManager.fruitTypes) do
    local soilData = g_farmlandManager:getFarmlandAtWorldPosition(0, 0) -- Adjust position as needed
    local soilMultiplier = 1

    if soilData ~= nil and soilData.fertilization ~= nil and soilData.pH ~= nil then
      soilMultiplier = soilData.fertilization * soilData.pH -- Adjust calculation based on soil properties
    end

    self.fruitTypesYield[fruitType.index] = fruitType.literPerSqm
    fruitType.literPerSqm = self.fruitTypesYield[fruitType.index] * self.yield * soilMultiplier
  end
end

function RandomYield:loadMap(name)
  if g_currentMission:getIsServer() then
    self:randomizeYields()
  end
  g_messageCenter:subscribe(MessageType.PERIOD_CHANGED, self.onPeriodChanged, self)
end

function RandomYield:onPeriodChanged(data)
  self.yield = math.random() * 1.2 + 0.3
  if self.yield > 1.1 then
    self.yield = g_currentMission.fruitTypeManager.defaultLiterPerSqm
  end
  if g_currentMission:getIsServer() then
    self:randomizeYields()
  end
end

function RandomYield:loadCustomMap(name)
  if g_currentMission:getIsServer() then
    self:randomizeYields()
  end
  g_messageCenter:subscribe(MessageType.PERIOD_CHANGED, self.onPeriodChanged, self)
end

function RandomYield:load()
  addModEventListener(self)
end

function RandomYield:delete()
  g_messageCenter:unsubscribeAll(self)
end

addModEventListener(RandomYield)